// Programming Techniques - Project
// Ken Webb
// January 5, 2004
// Queue.cpp: implementation of the Queue class.
//
//////////////////////////////////////////////////////////////////////

#include "Queue.h"
#include "Msg.h"
#include <stdio.h>

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

// Don't use this constructor
Queue::Queue()
{
	nextOn      = 0;
	nextOff     = 0;
	maxSize     = 0;
	currentSize = 0;
}

Queue::Queue(unsigned int numItems)
{
    nextOn      = 0;
    nextOff     = 0;
    maxSize     = numItems;
    currentSize = 0;
	// allocate space for the item data structure
	item = new void*[numItems];
}

Queue::~Queue()
{

}

//////////////////////////////////////////////
// enqueue - add an item to the queue
//////////////////////////////////////////////
int Queue::enqueue( void* p_item )
{
	if (currentSize >= maxSize)
		return Q_FULL;

	item[nextOn] = p_item;
	currentSize++;
	nextOn++;
	nextOn %= maxSize;

	return Q_OK;
}

///////////////////////////////////////////////
// dequeue - take an item off the queue
///////////////////////////////////////////////
void* Queue::dequeue( void )
{
	void* p_item;
	if (currentSize == 0)
		return Q_EMPTY;

	p_item = item[nextOff];
	currentSize--;
	nextOff++;
	nextOff %= maxSize;
	return p_item;
}

//////////////////////////////////////////////////////////////
// getSize - get number of items currently in the queue
//////////////////////////////////////////////////////////////
unsigned int Queue::getSize( void )
{
    return currentSize;
}
