// Programming Techniques - Project
// Ken Webb
// January 5, 2004
// Queue.h: interface for the Queue class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_QUEUE_H__2DC20400_AA0B_4698_9583_65C00625DC4A__INCLUDED_)
#define AFX_QUEUE_H__2DC20400_AA0B_4698_9583_65C00625DC4A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/**************************************************************************************
                                        Queue

This is a generic Queue data structure that can be used to store pointers
to any type of data. Items are added at one end of the Queue and taken
off at the other end, which is why a Queue is called a First In First Out
(FIFO) structure.

Warning: A Queue can fill up to maximum capacity, or it may become empty.
Check the return value when calling the enqueue and dequeue functions to
see if it is Q_FULL or Q_EMPTY.
**************************************************************************************/

// Special values to indicate Queue Full and Queue Empty
const int Q_FULL  = 0;
const int Q_EMPTY = 0;
const int Q_OK    = 1;

class Queue  
{
public:
	// Constructors and Destructors
	Queue(); // don't use
	Queue(unsigned int numItems);
	virtual ~Queue();

	int enqueue( void* p_item );  // Add an item to the queue
	void* dequeue( void );        // Take an item off the queue
	unsigned int getSize( void ); // Get number of items currently in the queue

private:
	// Queue Header
	unsigned int nextOn;      // next slot to use when enqueuing an item
	unsigned int nextOff;     // next slot to use when dequeuing an item
	unsigned int maxSize;     // max number of items in the queue body
	unsigned int currentSize; // current number of items in the queue body
	// Queue Body
	void **item;          // item pointers that are added to queue
};

#endif // !defined(AFX_QUEUE_H__2DC20400_AA0B_4698_9583_65C00625DC4A__INCLUDED_)
